genbki.sh 11.1 KB
Newer Older
1
#! /bin/sh
2 3 4 5 6 7 8
#-------------------------------------------------------------------------
#
# genbki.sh--
#    shell script which generates .bki files from specially formatted .h
#    files.  These .bki files are used to initialize the postgres template
#    database.
#
9
# Portions Copyright (c) 1996-2008, PostgreSQL Global Development Group
10
# Portions Copyright (c) 1994, Regents of the University of California
11 12 13
#
#
# IDENTIFICATION
14
#    $PostgreSQL: pgsql/src/backend/catalog/genbki.sh,v 1.45 2008/07/19 04:01:29 tgl Exp $
15 16 17 18
#
# NOTES
#    non-essential whitespace is removed from the generated file.
#    if this is ever a problem, then the sed script at the very
19
#    end can be changed into another awk script or something smarter.
20 21
#
#-------------------------------------------------------------------------
22

23
: ${AWK='awk'}
24

25
CMDNAME=`basename $0`
26

27
INCLUDE_DIRS=
28 29
OUTPUT_PREFIX=
INFILES=
P
Peter Eisentraut 已提交
30
major_version=
31

32 33 34 35
#
# Process command line switches.
#
while [ $# -gt 0 ]
36
do
37 38
    case $1 in
        -I)
39
            INCLUDE_DIRS="$INCLUDE_DIRS $2"
40 41
            shift;;
        -I*)
42 43
            arg=`echo $1 | sed -e 's/^-I//'`
            INCLUDE_DIRS="$INCLUDE_DIRS $arg"
44 45 46 47 48
            ;;
        -o)
            OUTPUT_PREFIX="$2"
            shift;;
        -o*)
49
            OUTPUT_PREFIX=`echo $1 | sed -e 's/^-o//'`
50
            ;;
P
Peter Eisentraut 已提交
51 52 53 54
        --set-version=*)
            arg=`expr x"$1" : x"--set-version=\(.*\)"`
            major_version=`expr x"$arg" : x'\([0-9][0-9]*\.[0-9][0-9]*\)'`
            ;;
55 56 57 58
        --help)
            echo "$CMDNAME generates system catalog bootstrapping files."
            echo
            echo "Usage:"
59
            echo "  $CMDNAME [ -I dir ] --set-version=VERSION -o prefix files..."
60 61
            echo
            echo "Options:"
62
            echo "  -I  path to include files"
63
            echo "  -o  prefix of output files"
P
Peter Eisentraut 已提交
64
            echo "  --set-version  PostgreSQL version number for initdb cross-check"
65
            echo
66 67
            echo "The environment variable AWK determines which Awk program"
            echo "to use. The default is \`awk'."
68 69 70 71
            echo
            echo "Report bugs to <pgsql-bugs@postgresql.org>."
            exit 0
            ;;
72
        -*)
73 74 75 76 77 78
            echo "$CMDNAME: invalid option: $1"
            exit 1
            ;;
        *)
            INFILES="$INFILES $1"
            ;;
79 80 81 82
    esac
    shift
done

83 84 85 86 87 88 89 90 91 92
if [ x"$INFILES" = x"" ] ; then
    echo "$CMDNAME: no input files" 1>&2
    exit 1
fi

if [ x"$OUTPUT_PREFIX" = x"" ] ; then
    echo "$CMDNAME: no output prefix specified" 1>&2
    exit 1
fi

93
if [ x"$INCLUDE_DIRS" = x"" ] ; then
94 95 96 97
    echo "$CMDNAME: path to include directory unknown" 1>&2
    exit 1
fi

P
Peter Eisentraut 已提交
98 99 100 101
if [ x"$major_version" = x"" ] ; then
    echo "$CMDNAME: invalid or no version number specified" 1>&2
    exit 1
fi
102 103


104
TMPFILE="genbkitmp$$.c"
105

106
trap "rm -f $TMPFILE ${OUTPUT_PREFIX}.bki.$$ ${OUTPUT_PREFIX}.description.$$ ${OUTPUT_PREFIX}.shdescription.$$" 0 1 2 3 15
107 108


109 110 111 112 113
# CAUTION: be wary about what symbols you substitute into the .bki file here!
# It's okay to substitute things that are expected to be really constant
# within a given Postgres release, such as fixed OIDs.  Do not substitute
# anything that could depend on platform or configuration.  (The right place
# to handle those sorts of things is in initdb.c's bootstrap_template1().)
114

115 116 117 118 119 120 121 122
# Get BOOTSTRAP_SUPERUSERID from catalog/pg_authid.h
for dir in $INCLUDE_DIRS; do
    if [ -f "$dir/catalog/pg_authid.h" ]; then
        BOOTSTRAP_SUPERUSERID=`grep '^#define[ 	]*BOOTSTRAP_SUPERUSERID' $dir/catalog/pg_authid.h | $AWK '{ print $3 }'`
        break
    fi
done

123 124 125 126 127 128 129 130
# Get PG_CATALOG_NAMESPACE from catalog/pg_namespace.h
for dir in $INCLUDE_DIRS; do
    if [ -f "$dir/catalog/pg_namespace.h" ]; then
        PG_CATALOG_NAMESPACE=`grep '^#define[ 	]*PG_CATALOG_NAMESPACE' $dir/catalog/pg_namespace.h | $AWK '{ print $3 }'`
        break
    fi
done

P
Peter Eisentraut 已提交
131
touch ${OUTPUT_PREFIX}.description.$$
132
touch ${OUTPUT_PREFIX}.shdescription.$$
P
Peter Eisentraut 已提交
133

134
# ----------------
135 136 137 138 139 140 141
# 	Strip comments and other trash from .h
#
#	Put multi-line start/end comments on a separate line
#
#	Rename datatypes that have different names in .h files than in SQL
#
#	Substitute values of configuration constants
142 143
# ----------------
#
144
cat $INFILES | \
B
Bruce Momjian 已提交
145 146 147 148 149 150 151
sed -e 's;/\*.*\*/;;g' \
    -e 's;/\*;\
/*\
;g' \
    -e 's;\*/;\
*/\
;g' | # we must run a new sed here to see the newlines we added
B
Hi,  
Bruce Momjian 已提交
152 153
sed -e "s/;[ 	]*$//g" \
    -e "s/^[ 	]*//" \
154
    -e "s/[ 	]Oid/ oid/g" \
B
Hi,  
Bruce Momjian 已提交
155
    -e "s/^Oid/oid/g" \
156 157
    -e "s/(Oid/(oid/g" \
    -e "s/[ 	]NameData/ name/g" \
158
    -e "s/^NameData/name/g" \
B
Hi,  
Bruce Momjian 已提交
159
    -e "s/(NameData/(name/g" \
160 161 162
    -e "s/[ 	]TransactionId/ xid/g" \
    -e "s/^TransactionId/xid/g" \
    -e "s/(TransactionId/(xid/g" \
163
    -e "s/PGUID/$BOOTSTRAP_SUPERUSERID/g" \
164
    -e "s/PGNSP/$PG_CATALOG_NAMESPACE/g" \
165
| $AWK '
166 167 168 169 170 171
# ----------------
#	now use awk to process remaining .h file..
#
#	nc is the number of catalogs
#	inside is a variable set to 1 when we are scanning the
#	   contents of a catalog definition.
172 173
#	reln_open is a flag indicating when we are processing DATA lines.
#	   (i.e. have a relation open and need to close it)
174
#	oid is the most recently seen oid, or 0 if none in the last DATA line.
175 176 177
# ----------------
BEGIN {
	inside = 0;
178
	bootstrap = "";
179
	shared_relation = "";
180
	without_oids = "";
181 182
	nc = 0;
	reln_open = 0;
183 184
	comment_level = 0;
	oid = 0;
185 186
}

187 188 189 190 191 192 193
# ----------------
# Anything in a /* .. */ block should be ignored.
# Blank lines also go.
# Note that any /* */ comment on a line by itself was removed from the line
# by the sed above.
# ----------------
/^\/\*/           { comment_level += 1; next; }
194
/^\*\//           { comment_level -= 1; next; }
195 196 197 198
comment_level > 0 { next; }

/^[ 	]*$/      { next; }

199
# ----------------
200
#	DATA() statements are basically passed right through after
201
#	stripping off the DATA( and the ) on the end.
202
#	Remember the OID for use by DESCR() and SHDESCR().
203 204 205
# ----------------
/^DATA\(/ {
	data = substr($0, 6, length($0) - 6);
206
	oid = 0;
207 208
	nf = split(data, datafields);
	if (nf >= 4 && datafields[1] == "insert" && datafields[2] == "OID" && datafields[3] == "=")
209
	{
210
		oid = datafields[4];
211
	}
212
	print data;
213 214 215 216 217 218 219 220
	next;
}

/^DESCR\(/ {
	if (oid != 0)
	{
		data = substr($0, 8, length($0) - 9);
		if (data != "")
221
			printf "%d\t%s\t0\t%s\n", oid, catalog, data >>descriptionfile;
222
	}
223 224 225
	next;
}

226 227 228 229 230 231 232 233 234 235
/^SHDESCR\(/ {
	if (oid != 0)
	{
		data = substr($0, 10, length($0) - 11);
		if (data != "")
			printf "%d\t%s\t%s\n", oid, catalog, data >>shdescriptionfile;
	}
	next;
}

236 237 238 239 240 241 242 243 244 245
/^DECLARE_INDEX\(/ {
# ----
#  end any prior catalog data insertions before starting a define index
# ----
	if (reln_open == 1) {
		print "close " catalog;
		reln_open = 0;
	}

	data = substr($0, 15, length($0) - 15);
246 247 248 249
	pos = index(data, ",");
	iname = substr(data, 1, pos-1);
	data = substr(data, pos+1, length(data)-pos);
	pos = index(data, ",");
250
	oid = substr(data, 1, pos-1);
251 252
	data = substr(data, pos+1, length(data)-pos);

253
	print "declare index " iname " " oid " " data
254 255
}

256 257 258 259 260 261 262 263 264 265
/^DECLARE_UNIQUE_INDEX\(/ {
# ----
#  end any prior catalog data insertions before starting a define unique index
# ----
	if (reln_open == 1) {
		print "close " catalog;
		reln_open = 0;
	}

	data = substr($0, 22, length($0) - 22);
266 267 268 269
	pos = index(data, ",");
	iname = substr(data, 1, pos-1);
	data = substr(data, pos+1, length(data)-pos);
	pos = index(data, ",");
270
	oid = substr(data, 1, pos-1);
271 272
	data = substr(data, pos+1, length(data)-pos);

273
	print "declare unique index " iname " " oid " " data
274 275
}

276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297
/^DECLARE_TOAST\(/ {
# ----
#  end any prior catalog data insertions before starting a define toast
# ----
	if (reln_open == 1) {
		print "close " catalog;
		reln_open = 0;
	}

	data = substr($0, 15, length($0) - 15);
	pos = index(data, ",");
	tname = substr(data, 1, pos-1);
	data = substr(data, pos+1, length(data)-pos);
	pos = index(data, ",");
	toastoid = substr(data, 1, pos-1);
	data = substr(data, pos+1, length(data)-pos);
	# previous commands already removed the trailing );
	indexoid = data;

	print "declare toast " toastoid " " indexoid " on " tname
}

298 299 300 301 302 303 304 305 306 307 308 309 310 311 312
/^BUILD_INDICES/	{ print "build indices"; }
	
# ----------------
#	CATALOG() definitions take some more work.
# ----------------
/^CATALOG\(/ { 
# ----
#  end any prior catalog data insertions before starting a new one..
# ----
	if (reln_open == 1) {
		print "close " catalog;
		reln_open = 0;
	}

# ----
313
#  get the name and properties of the new catalog
314 315
# ----
	pos = index($1,")");
316 317 318
	catalogandoid = substr($1,9,pos-9);
	pos = index(catalogandoid, ",");
	catalog = substr(catalogandoid, 1, pos-1);
319
	oid = substr(catalogandoid, pos+1, length(catalogandoid)-pos);
320

321
	if ($0 ~ /BKI_BOOTSTRAP/) {
322 323
		bootstrap = "bootstrap ";
	}
324 325 326
	if ($0 ~ /BKI_SHARED_RELATION/) {
		shared_relation = "shared_relation ";
	}
327 328
	if ($0 ~ /BKI_WITHOUT_OIDS/) {
		without_oids = "without_oids ";
329 330 331 332 333 334 335 336 337
	}

        i = 1;
	inside = 1;
        nc++;
	next;
}

# ----------------
338
#	process the columns of the catalog definition
339 340 341 342 343 344 345 346 347 348 349 350 351 352 353
#
#	attname[ x ] contains the attribute name for attribute x
#	atttype[ x ] contains the attribute type fot attribute x
# ----------------
inside == 1 {
# ----
#  ignore a leading brace line..
# ----
        if ($1 ~ /\{/)
		next;

# ----
#  if this is the last line, then output the bki catalog stuff.
# ----
	if ($1 ~ /}/) {
354
		print "create " bootstrap shared_relation without_oids catalog " " oid;
355 356 357 358 359 360 361 362
		print "\t(";

		for (j=1; j<i-1; j++) {
			print "\t " attname[ j ] " = " atttype[ j ] " ,";
		}
		print "\t " attname[ j ] " = " atttype[ j ] ;
		print "\t)";

363
		if (bootstrap == "") {
364 365 366 367 368 369
			print "open " catalog;
		}

		i = 1;
		reln_open = 1;
		inside = 0;
370
		bootstrap = "";
371
		shared_relation = "";
372
		without_oids = "";
373 374 375 376
		next;
	}

# ----
377
#  we are inside the catalog definition, so keep sucking up
378
#  attribute names and types
379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397
# ----
	if ($2 ~ /\[.*\]/) {			# array attribute
		idlen = index($2,"[") - 1;
		atttype[ i ] = $1 "[]";		# variable-length only..
		attname[ i ] = substr($2,1,idlen);
	} else {
		atttype[ i ] = $1;
		attname[ i ] = $2;
	}
	i++;
	next;
}

END {
	if (reln_open == 1) {
		print "close " catalog;
		reln_open = 0;
	}
}
398
' "descriptionfile=${OUTPUT_PREFIX}.description.$$" "shdescriptionfile=${OUTPUT_PREFIX}.shdescription.$$" > $TMPFILE || exit
P
Peter Eisentraut 已提交
399 400

echo "# PostgreSQL $major_version" >${OUTPUT_PREFIX}.bki.$$
401

402
sed -e '/^[ 	]*$/d' \
403
    -e 's/[ 	][ 	]*/ /g' $TMPFILE >>${OUTPUT_PREFIX}.bki.$$ || exit
404

405 406 407 408 409 410 411 412 413 414 415 416 417 418
#
# Sanity check: if one of the sed/awk/etc commands fails, we'll probably
# end up with a .bki file that is empty or just a few lines.  Cross-check
# that the files are of reasonable size.  The numbers here are arbitrary,
# but are much smaller than the actual expected sizes as of Postgres 7.2.
#
if [ `wc -c < ${OUTPUT_PREFIX}.bki.$$` -lt 100000 ]; then
    echo "$CMDNAME: something seems to be wrong with the .bki file" >&2
    exit 1
fi
if [ `wc -c < ${OUTPUT_PREFIX}.description.$$` -lt 10000 ]; then
    echo "$CMDNAME: something seems to be wrong with the .description file" >&2
    exit 1
fi
419 420 421 422
if [ `wc -c < ${OUTPUT_PREFIX}.shdescription.$$` -lt 10 ]; then
    echo "$CMDNAME: something seems to be wrong with the .shdescription file" >&2
    exit 1
fi
423 424 425

# Looks good, commit ...

P
Peter Eisentraut 已提交
426 427
mv ${OUTPUT_PREFIX}.bki.$$ ${OUTPUT_PREFIX}.bki || exit
mv ${OUTPUT_PREFIX}.description.$$ ${OUTPUT_PREFIX}.description || exit
428
mv ${OUTPUT_PREFIX}.shdescription.$$ ${OUTPUT_PREFIX}.shdescription || exit
429

430
exit 0